VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CommandList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements ICommand
Implements ICommandListener
Private m_Arr() As ICommand
Private m_Count As Long
Private m_Index As Long
Private m_Incrm As Long
Private m_Parent As ICommandListener

Private Sub Class_Initialize()
    ReDim m_Arr(0 To 3)
End Sub

Public Sub Add(aObj As ICommand)
    If UBound(m_Arr) = m_Count Then ReDim Preserve m_Arr(0 To m_Count * 2 - 1)
    Set m_Arr(m_Count) = aObj
    Set aObj.Parent = Me
    m_Count = m_Count + 1
End Sub

Private Property Set ICommand_Parent(RHS As ICommandListener)
    Set m_Parent = RHS
End Property
    
Public Property Get CanExecute() As Boolean
    CanExecute = 0 <= m_Index And m_Index < m_Count
End Property

Public Property Get CanRollBack() As Boolean
    CanRollBack = 0 < m_Index And m_Index <= m_Count
End Property

Private Sub ICommand_Execute()
    m_Incrm = 1
    If Me.CanExecute Then
        m_Arr(m_Index).Execute
        m_Index = m_Index + m_Incrm
    End If
End Sub

Private Sub ICommand_RollBack()
    m_Incrm = -1
    If Me.CanRollBack Then
        m_Index = m_Index + m_Incrm
        m_Arr(m_Index).RollBack
    End If
End Sub

Private Sub ICommandListener_Done()
    If m_Incrm > 0 Then
        If Me.CanExecute Then
            ICommand_Execute
        Else
            m_Parent.Done
        End If
    ElseIf m_Incrm < 0 Then
        If Me.CanRollBack Then
            ICommand_RollBack
        Else
            m_Parent.Done
        End If
    End If
End Sub
