VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CommandMouseMove"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements ICommand
Private m_Mouse As AniMouse
Private WithEvents mTim As Timer
Attribute mTim.VB_VarHelpID = -1
Private m_Speed As Single
Private m_LastX As Single 'von wo die Maus startet
Private m_LastY As Single
Private m_GoalX As Single 'wo die Maus sich hinbewegen soll
Private m_GoalY As Single
Private m_dx    As Single 'die Bewegung eines Bildschrittes in x-Ri
Private m_dy    As Single 'die Bewegung eines Bildschrittes in y-Ri
Private m_MaxSteps    As Long 'die Anzahl an Schritten
Private m_StepCounter As Long
Private m_Parent As ICommandListener

Friend Sub New_(aTimer As Timer, aMouse As AniMouse, ByVal ToX As Double, ByVal ToY As Double)
    Set m_Mouse = aMouse: Set mTim = aTimer
    m_GoalX = ToX: m_GoalY = ToY
    m_Speed = 50 'Pixel pro Bild wir werden sehen ob das schnell genug ist
    mTim.Enabled = False
    mTim.Interval = 40 '40ms=25Bilder/Sec sollte reichen
End Sub

Private Sub ICommand_Execute()
    If mTim.Enabled Then Exit Sub
    'die letzte Position speichern
    m_LastX = m_Mouse.PosX '544
    m_LastY = m_Mouse.PosY '328
    'die gesamt zurckzulegende Strecke dist
    Dim dx As Single: dx = m_GoalX - m_LastX
    Dim dy As Single: dy = m_GoalY - m_LastY
    Dim dist As Single: dist = Math.Sqr(dx * dx + dy * dy)
    If dist = 0 Then Exit Sub
    m_MaxSteps = dist / m_Speed 'die Anzahl der fr die Bewegung erforderlichen Schritte
    If m_MaxSteps = 0 Then Exit Sub
    m_dx = dx / m_MaxSteps 'Strecke eines Bildes in x
    m_dy = dy / m_MaxSteps 'Strecke eines Bildes in y
    mTim.Enabled = True
End Sub

Private Sub ICommand_RollBack()
    If mTim.Enabled Then Exit Sub
    Dim GoalX As Single: GoalX = m_LastX
    Dim GoalY As Single: GoalY = m_LastY
    m_LastX = m_Mouse.PosX
    m_LastY = m_Mouse.PosY
    'die gesamt zurckzulegende Strecke dist
    Dim dx As Single: dx = GoalX - m_LastX
    Dim dy As Single: dy = GoalY - m_LastY
    Dim dist As Single: dist = Math.Sqr(dx * dx + dy * dy)
    If dist = 0 Then Exit Sub
    m_MaxSteps = dist / m_Speed 'die Anzahl der fr die Bewegung erforderlichen Schritte
    If m_MaxSteps = 0 Then Exit Sub
    m_dx = dx / m_MaxSteps 'Strecke eines Bildes in x
    m_dy = dy / m_MaxSteps 'Strecke eines Bildes in y
    mTim.Enabled = True
End Sub

Private Property Set ICommand_Parent(RHS As ICommandListener)
    Set m_Parent = RHS
End Property

Private Sub mTim_Timer()
    m_StepCounter = m_StepCounter + 1
    
    m_Mouse.Move m_LastX + m_StepCounter * m_dx, m_LastY + m_StepCounter * m_dy
    If m_StepCounter = m_MaxSteps Then
        m_StepCounter = 0
        mTim.Enabled = False
        'Debug.Print "Mouse ist an Position: (X: " & m_Mouse.PosX & " Y: " & m_Mouse.PosY & ") angekommen"
        If Not m_Parent Is Nothing Then
            'Debug.Print "LastXY: " & m_LastX & ", " & m_LastY & " - " & " GoalXY: " & m_GoalX & ", " & m_GoalY
            m_Parent.Done
        End If
    End If
End Sub
